import React from "react";

import { IAccount, IMailbox } from "./client/types";
import Client from "./client/Client";
import EmailList from "./EmailList";

type MailboxProps = {
	account: IAccount | null;
	client: Client;
	mailbox: IMailbox | null;
};

type MailboxState = {};

class Mailbox extends React.Component<MailboxProps, MailboxState> {
	componentDidUpdate() {
		if (this.props.account == null) return;
		if (this.props.client == null) return;
		if (this.props.mailbox == null) return;
		this.props.client.ensureMailbox(
			this.props.account.id,
			this.props.mailbox.id,
		);
	}

	render() {
		return (
			<EmailList
				account={this.props.account}
				client={this.props.client}
				mailbox={this.props.mailbox}
			/>
		);
	}
}

export default Mailbox;
