import * as client from "./jmap-client-ts/src/types";

export type MailboxIdMapPresence = { [mailboxId: string]: boolean };
export interface IEmailStub {
	from: Array<client.IEmailAddress>;
	id: string;
	mailboxIds: MailboxIdMapPresence;
	receivedAt: string;
	subject: string;
}

export interface IMailbox extends client.IMailboxProperties {
	emailIds: Array<string> | null;
}
export type MailboxIdMap = { [mailboxId: string]: IMailbox };

export interface IEmail extends client.IEmailProperties {
	//sentAt: IutcDate|null,
}

export interface IAccount extends client.IAccount {
	id: string;
	mailboxes: MailboxIdMap | null;

	mailboxByRole(role: MailboxRole): IMailbox | null;
}
export type MailboxRole =
	| "all"
	| "archive"
	| "drafts"
	| "flagged"
	| "important"
	| "junk"
	| "sent"
	| "subscribed"
	| "trash";
export type PushMessage = client.PushMessage;
export type AccountIdMap = { [accountId: string]: IAccount };
export type EmailStubIdMap = { [emailId: string]: IEmailStub };
export type EmailIdMap = { [emailId: string]: IEmail };

export interface ISession extends client.ISession {
	accounts: AccountIdMap;
	emails: EmailIdMap;
	emailStubs: EmailStubIdMap;
	mailboxes: MailboxIdMap;
}
